Foreman - Bug #5883

Host: provide user indication that the build token has expired
05/22/2014 06:01 PM - Brad Buckingham

Status: Closed
Priority: Normal
Assignee: Julien Pivotto
Category: Web Interface
Target version: 1.12.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3251
Description

While setting up a new development environment, | needed to go through a few iterations on the configuration to get it to the point
where | could successfully provision a host. During this process, | created a host in the Ul and by the time | had everything set to
provision the host, the build token had expired. This led to what appeared to be a provisioning loop. In the production log, there was
a 404 on the 'built' request; however, it wasn't really that obvious what the issue was or how to resolve it.

We may want to consider possible solutions to help users that might encounter this scenario. For example,

1. provide some text or indication in the Ul that the build token has expired and that the build should be cancelled & initiated to
generate a new token

2. might want to re-consider if 60 minutes is a good default for the token, to minimize the frequency of the timeouts, while still
providing the security intended

3+. ...

(Note: | was using bootdisk, so | created the host in foreman and then initiated the vm creation from virt-manager).

The following is an example of the error in the logs:

Rendered /home/bbucking/.rvm/gems/ruby-1.9.3-pd448Q@fortello/gems/actionpack-3.2.18/1lib/action_dis
patch/middleware/templates/rescues/routing_error.erb within rescues/layout (0.5ms)
Processing by UnattendedController#built as */*

Parameters: {"token"=>"3d0a0855-dblc—-4eel-8880-6c4a95d4calld"}

A [1m” [ [35mHost: :Managed Load (0.5ms)”[[Om SELECT hosts.* FROM "hosts" INNER JOIN "tokens" ON "
tokens"."host_id" = "hosts"."id" WHERE "hosts"."type" IN ('Host::Managed') AND "tokens"."value" =
'3d0a0855-dblc-4eel-8880-6c4a95d4cal8' AND (expires >= '2014-05-22 16:20:01') LIMIT 1

A [1m~ [ [36mHost: :Managed Load (0.2ms)”[[Om ~[[1ImSELECT "hosts".* FROM "hosts" WHERE "hosts"."ty
pe" IN ('Host::Managed') AND "hosts"."ip" = '192.168.122.23' LIMIT 1°[[Om
unattended: unable to find a host that matches the request from 192.168.122.23
Filter chain halted as :get_host_details rendered or redirected
Completed 404 Not Found in 3.7ms (ActiveRecord: 0.7ms)

Related issues:
Related to Foreman - Bug #14050: N+1 query on hosts#index from host's build t... Closed 03/04/2016

Associated revisions

Revision 5e1b7875 - 03/02/2016 08:03 AM - Julien Pivotto

Fixes #5883 - Reflect token expiry in build status

The Global Status introduced in recent Foreman releases makes it easy to
mark the build status as erroneous if the token has expired. This drags

attention to the fact that the host will not be able to mark itself as
built anymore.

History

#1 - 05/22/2014 06:02 PM - Greg Sutcliffe
+1 - from IRC:

<gwmngilfen> i think some small text on/near the Cancel Build button when build=true and token=expired would suit

#2 - 06/17/2014 11:32 AM - David Schmitt

See also #6247, another problem in this area.

#3 - 09/25/2014 05:16 AM - David Schmitt

Some more notes from IRC after | hit this problem again.

e When the token is not valid anymore, the host is not in Build mode anymore. This is due to the fact that the host cannot be built anymore.

¢ The node should be marked as erroneous if it is not built (correctly).
* The /unattended/provision script can be fetched even if the token is not valid.

A few possibilities to go forward on this:

e Make the token timeout configurable/infinite
o Pro: easy to do

o Con: makes unclaimed tokens a liability. Mitigation: mark unbuilt hosts with a separate out-of-sync state to make them discoverable.
o This would probably imply tightening down /unattended/* to always require a token. (except for hosts that can only be authd by IP/MAC, e.g.

because of booting from the generic bootimage iso)

e refresh the token if /unattended/provision is called.
o Pro: very localized change

o Con: This requires authnz via IP/MAC on API call, and relies on this authnz to supersede the token lifetime.

¢ use IP/MAC authnz for /unattended/built
o Pro: makes built and provision work the same
o Con: why have a token anyways?

#4 - 02/29/2016 07:58 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Julien Pivotto

- Pull request https://github.com/theforeman/foreman/pull/3251 added

#5 - 02/29/2016 08:05 AM - Julien Pivotto
- File fna100.png added

- Assignee deleted (Julien Pivotto)

| did use the new "global status" feature to address this ticket.

#6 - 02/29/2016 08:13 AM - Julien Pivotto

- Assignee set to Julien Pivotto

#7 - 03/02/2016 09:01 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 5e1b787534cb4af70075640928edab5588b1c984.

#8 - 03/03/2016 06:00 AM - Dominic Cleal

- translation missing: en.field_release set to 136

#9 - 03/04/2016 08:34 AM - Dominic Cleal
- Related to Bug #14050: N+1 query on hosts#index from host's build token added
